Index: trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.pbproj/project.pbxproj
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.pbproj/project.pbxproj	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/F-Script Anywhere.pbproj/project.pbxproj	(revision 153)
@@ -565,59 +1473,28 @@
 			path = "";
 			refType = 4;
-		};
-		F52D400302D2C7A201AEEDB1 = {
-			buildActionMask = 12;
-			dstPath = "${DSTROOT}";
-			dstSubfolderSpec = 0;
-			files = (
-				F52D400402D2C7A501AEEDB1,
-			);
-			isa = PBXCopyFilesBuildPhase;
-			runOnlyForDeploymentPostprocessing = 0;
-		};
-		F52D400402D2C7A501AEEDB1 = {
-			fileRef = F5680F83020D369A01AEEC37;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F535E67D020CD95201AEEC37 = {
 			isa = PBXFileReference;
+			lastKnownFileType = image.icns;
 			path = "Application icon.icns";
 			refType = 4;
-		};
-		F535E67E020CD95201AEEC37 = {
-			fileRef = F535E67D020CD95201AEEC37;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F535E680020CDD4601AEEC37 = {
-			fileRef = 103DFC1A016C16650C000109;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F53A0D8202750B1F01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = "NSTableView-NJRExtensions.h";
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F53A0D8302750B1F01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = "NSTableView-NJRExtensions.m";
 			refType = 4;
-		};
-		F53A0D8402750B1F01AEEDB1 = {
-			fileRef = F53A0D8202750B1F01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F53A0D8502750B1F01AEEDB1 = {
-			fileRef = F53A0D8302750B1F01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5680F7A020D0D0401AEEC37 = {
@@ -629,206 +1506,157 @@
 			path = "";
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5680F7B020D0D0401AEEC37 = {
 			isa = PBXFileReference;
+			lastKnownFileType = wrapper.nib;
 			name = English;
 			path = English.lproj/FSAInterpreterPanel.nib;
 			refType = 4;
-		};
-		F5680F7C020D0D0401AEEC37 = {
-			fileRef = F5680F7A020D0D0401AEEC37;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5680F7F020D35ED01AEEC37 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = text;
 			path = "Read Me";
 			refType = 4;
-		};
-		F5680F81020D365601AEEC37 = {
-			buildActionMask = 8;
-			files = (
-			);
-			generatedFileNames = (
-			);
-			isa = PBXShellScriptBuildPhase;
-			neededFileNames = (
-			);
-			runOnlyForDeploymentPostprocessing = 1;
-			shellPath = /bin/sh;
-			shellScript = "# Copy various README files into DSTROOT if building a root\n\nif [ z\"${DSTROOT}\" != z\"\" ] ; then\n    rm -f \"${DSTROOT}/Read Me\"\n    tr '\\n' '\\r' < \"Read Me\" > \"${DSTROOT}/Read Me\"\n    cp \"Read Me.rsrc\" \"${DSTROOT}/Read Me/..namedfork/rsrc\"\n    /Developer/Tools/SetFile -t 'ttro' -c 'ttxt' \"${DSTROOT}/Read Me\"\n        \n    # Create Darwin source directory\n    mkdir \"${DSTROOT}/Darwin source\"\n    \n    # Fix permissions so ditto doesn't lock people out\n    chmod -R a+rX,u+w \"${DSTROOT}\"\nfi";
+			sourceTree = "<group>";
 		};
 		F5680F83020D369A01AEEC37 = {
 			isa = PBXFileReference;
+			lastKnownFileType = text.rtf;
 			name = LICENSE.rtf;
 			path = ../LICENSE.rtf;
 			refType = 2;
+			sourceTree = SOURCE_ROOT;
 		};
 		F5694E2702E96FFE01AEEDB1 = {
 			isa = PBXFileReference;
+			lastKnownFileType = image.tiff;
 			path = "Bullseye menu cursor.tiff";
 			refType = 4;
-		};
-		F5694E2802E96FFE01AEEDB1 = {
-			fileRef = F5694E2702E96FFE01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F574ADD5020AC10F01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = NJRScrollView.m;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F574ADD6020AC10F01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = NJRScrollView.h;
 			refType = 4;
-		};
-		F574ADD7020AC10F01AEEDB1 = {
-			fileRef = F574ADD6020AC10F01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F574ADD8020AC10F01AEEDB1 = {
-			fileRef = F574ADD5020AC10F01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F574ADDA020ACAC801AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = FSAController.h;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F574ADDB020ACAC801AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = FSAController.m;
 			refType = 4;
-		};
-		F574ADDF020ACCDF01AEEDB1 = {
-			fileRef = F574ADDA020ACAC801AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F574ADE0020ACCDF01AEEDB1 = {
-			fileRef = F574ADDB020ACAC801AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F57D63160319B6CA01AEEDB1 = {
 			isa = PBXFileReference;
+			lastKnownFileType = image.tiff;
 			path = "Fallback checkmark.tiff";
 			refType = 4;
-		};
-		F57D63170319B6CA01AEEDB1 = {
-			fileRef = F57D63160319B6CA01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F59279FA01FED09A01AEEC37 = {
-			fileRef = 1058C7A1FEA54F0111CA2CBB;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F59279FB01FED0C901AEEC37 = {
+			fallbackIsa = PBXFileReference;
 			isa = PBXFrameworkReference;
+			lastKnownFileType = wrapper.framework;
 			name = Carbon.framework;
 			path = /System/Library/Frameworks/Carbon.framework;
 			refType = 0;
+			sourceTree = "<absolute>";
 		};
 		F5B11ED902E67DB101AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = text;
 			path = VERSION;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2C3020A6C2601AEEDB1 = {
+			fallbackIsa = PBXFileReference;
 			isa = PBXFrameworkReference;
+			lastKnownFileType = wrapper.framework;
 			name = FScript.framework;
 			path = /Library/Frameworks/FScript.framework;
 			refType = 0;
-		};
-		F5EFC2C4020A6C2601AEEDB1 = {
-			fileRef = F5EFC2C3020A6C2601AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<absolute>";
 		};
 		F5EFC2C9020A6CD101AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = DeVercruesseProcess.m;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2CA020A6CD101AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = DeVercruesseProcessManager.m;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2CB020A6CD101AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = DeVercruesseProcess.h;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2CC020A6CD101AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = DeVercruesseProcessManager.h;
 			refType = 4;
-		};
-		F5EFC2CD020A6CD101AEEDB1 = {
-			fileRef = F5EFC2CB020A6CD101AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5EFC2CE020A6CD101AEEDB1 = {
-			fileRef = F5EFC2CC020A6CD101AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5EFC2CF020A6CD101AEEDB1 = {
-			fileRef = F5EFC2C9020A6CD101AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5EFC2D0020A6CD101AEEDB1 = {
-			fileRef = F5EFC2CA020A6CD101AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5EFC2D1020A6CEC01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = CPS.h;
 			refType = 4;
-		};
-		F5EFC2D2020A6CEC01AEEDB1 = {
-			fileRef = F5EFC2D1020A6CEC01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5EFC2D5020A6D3701AEEDB1 = {
-			fileRef = F59279FB01FED0C901AEEC37;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5EFC2D6020A6E0E01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = FSAAppList.h;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2D7020A6E0E01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = FSAAppList.m;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2D8020A6E0E01AEEDB1 = {
@@ -844,19 +1672,10 @@
 			path = "";
 			refType = 4;
-		};
-		F5EFC2D9020A6E0E01AEEDB1 = {
-			fileRef = F5EFC2D6020A6E0E01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5EFC2DA020A6E0E01AEEDB1 = {
-			fileRef = F5EFC2D7020A6E0E01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5EFC2DB020A6E4301AEEDB1 = {
 			children = (
+				E1EE98BB0575626E00F2D92C,
+				E1E4A92005A25F440097D040,
 				29B97316FDCFA39411CA2CEA,
 				103DFC16016C12D80C000109,
@@ -880,125 +1699,93 @@
 			path = "";
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2DC020A6EB901AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = "NSString-NJRExtensions.m";
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2DD020A6EB901AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = "NSString-NJRExtensions.h";
 			refType = 4;
-		};
-		F5EFC2DE020A6EB901AEEDB1 = {
-			fileRef = F5EFC2DD020A6EB901AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5EFC2DF020A6EB901AEEDB1 = {
-			fileRef = F5EFC2DC020A6EB901AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5EFC2E0020A6FD501AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = NJRLabeledImageCell.m;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2E1020A6FD501AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = NJRLabeledImageCell.h;
 			refType = 4;
-		};
-		F5EFC2E2020A6FD501AEEDB1 = {
-			fileRef = F5EFC2E1020A6FD501AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5EFC2E3020A6FD501AEEDB1 = {
-			fileRef = F5EFC2E0020A6FD501AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5EFC2E7020A8F7F01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = libMatch.h;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5EFC2E8020A8F7F01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.c;
 			path = libMatch.c;
 			refType = 4;
-		};
-		F5EFC2E9020A8F7F01AEEDB1 = {
-			fileRef = F5EFC2E7020A8F7F01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5EFC2EA020A8F7F01AEEDB1 = {
-			fileRef = F5EFC2E8020A8F7F01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5EFC2EB020A90DF01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.c;
 			path = bytesex.c;
 			refType = 4;
-		};
-		F5EFC2EC020A90DF01AEEDB1 = {
-			fileRef = F5EFC2EB020A90DF01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5FD7889034828E101AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = FSAWindowManager.h;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5FD788A034828E101AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = FSAWindowManager.m;
 			refType = 4;
-		};
-		F5FD788B034828E101AEEDB1 = {
-			fileRef = F5FD7889034828E101AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5FD788C034828E101AEEDB1 = {
-			fileRef = F5FD788A034828E101AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5FF50BC02E53B9E01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.h;
 			path = FSAViewAssociationController.h;
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5FF50BD02E53B9E01AEEDB1 = {
-			isa = PBXFileReference;
+			fileEncoding = 30;
+			isa = PBXFileReference;
+			lastKnownFileType = sourcecode.c.objc;
 			path = FSAViewAssociationController.m;
 			refType = 4;
-		};
-		F5FF50BE02E53B9E01AEEDB1 = {
-			fileRef = F5FF50BC02E53B9E01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
-		};
-		F5FF50BF02E53B9E01AEEDB1 = {
-			fileRef = F5FF50BD02E53B9E01AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 		F5FF50C002E53EE101AEEDB1 = {
@@ -1010,16 +1797,13 @@
 			path = "";
 			refType = 4;
+			sourceTree = "<group>";
 		};
 		F5FF50C102E53EE101AEEDB1 = {
 			isa = PBXFileReference;
+			lastKnownFileType = wrapper.nib;
 			name = English;
 			path = English.lproj/FSAViewAssociationPanel.nib;
 			refType = 4;
-		};
-		F5FF50C202E5418F01AEEDB1 = {
-			fileRef = F5FF50C002E53EE101AEEDB1;
-			isa = PBXBuildFile;
-			settings = {
-			};
+			sourceTree = "<group>";
 		};
 	};
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAApp.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAApp.h	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAApp.h	(revision 153)
@@ -28,20 +28,31 @@
 #import "FSAAppList.h"
 
+#include "SCPatchController.h"
+
+@class FSAApp;
+
+class FSAPatchController : public SCPatchController {
+public:
+    FSAPatchController(FSAApp *fsaApp);
+    void PatchNotification(ProcessSerialNumber *inPSN,
+                           OSType inCreator, OSType type,
+                           CFStringRef name, UInt32 flags);
+    void ReceiveMessage(const AppleEvent *theAE);
+private:
+    FSAApp *mApp;
+};
+
 @interface FSAApp : NSApplication
 {
-    IBOutlet NSPanel *appListPanel;
+    IBOutlet NSWindow *appListWindow;
     IBOutlet FSAAppList *appList;
+    FSAPatchController *patchController;
 }
 
-- (void) finishLaunching;
+- (IBAction)installBundleInSelectedApp:(id)sender;
 
-- (IBAction)installBundleInSelectedApp:(id)sender;
-- (void)unloadBundles:(id)sender;
 @end
 
-@interface FSAApp (PatchControllerDelegate)
-
-- (void) notifyProcessLaunch:(pid_t)pid info:(NSDictionary*)info;
-- (void) notifyProcessDeath:(pid_t)pid info:(NSDictionary*)info;
-
+@interface FSAApp (FSAPatchControllerDelegate)
+- (void)controllerIsPatchingApplicationWithProcessID:(pid_t)pid;
 @end
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAApp.mm
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAApp.mm	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAApp.mm	(revision 153)
@@ -0,0 +1,286 @@
+//
+//  FSAApp.m
+//  F-Script Anywhere
+//
+//  Created by Nicholas Riley on Fri Feb 01 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+/*
+
+ F-Script Anywhere is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2 of the License, or
+ (at your option) any later version.
+
+ F-Script Anywhere is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with F-Script Anywhere; if not, write to the Free Software
+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+*/
+
+#import "FSAApp.h"
+#import "FSAnywhere.h"
+
+NSString * const PatchBundleIdentifier = @"net.sabi.FScriptAnywhere";
+NSString * const PatchBundleName = @"F-Script Anywhere.bundle";
+
+typedef struct {
+    OSStatus err;
+    NSString * const desc;
+} errRec, errList[];
+
+// These are just educated guesses based on the errors I've seen; I haven't seen these documented anywhere!
+static errList ERRS = { // XXX change for mach_inject/SCPatch
+    { 5, @"F-Script Anywhere must be installed in a Cocoa application running as the current user.\n\nYou may be attempting to install in a setuid application, which is not supported" },
+    { 11, @"F-Script Anywhere cannot be installed in itself.\n\nIf you wish to install F-Script Anywhere in itself, make a copy of the F-Script Anywhere application and install one copy into the other" },
+    { smUnExBusErr, @"a bus error occurred.\n\nTry switching to the application first then using F-Script AnywhereÕs dock menu to install" },
+    { fnfErr, @"F-Script Anywhere was unable to locate its component to install in the application.  Please try reinstalling F-Script Anywhere" },
+    { cfragDupRegistrationErr, @"another running copy of F-Script Anywhere is already installed in the application"},
+    { 0, nil }
+};
+
+NSMutableDictionary *FSA_errors;
+
+NSString * FSA_descriptionForOSStatus(OSStatus err)
+{
+    NSString *desc = nil;
+    
+    if (FSA_errors != nil)
+        desc = [FSA_errors objectForKey: [NSNumber numberWithLong: err]];
+    
+    if (desc != nil)
+        return desc;
+    
+    return [NSString stringWithFormat: NSLocalizedString(@"an error of type %ld occurred", "Unknown error message used after 'XXX happened because'"), err];
+}
+
+FSAPatchController::FSAPatchController(FSAApp *fsaApp)
+{
+    mApp = fsaApp;
+}
+
+void FSAPatchController::PatchNotification(ProcessSerialNumber *inPSN, OSType inCreator, OSType type, CFStringRef name, UInt32 flags) {
+    pid_t pid;
+    OSStatus err = GetProcessPID(inPSN, &pid);
+    
+    NSCAssert3(err == noErr, @"PatchNotification can't get PID for PSN %ld.%ld: error %ld", inPSN->highLongOfPSN, inPSN->lowLongOfPSN, err);
+    
+    FSALog(@"Got patch notification for %@ (pid %d)", (NSString *)name, pid);
+    [mApp controllerIsPatchingApplicationWithProcessID: pid];
+}
+
+// XXX should remove?
+void FSAPatchController::ReceiveMessage(const AppleEvent *theAE) {
+    OSErr err = noErr;
+    Size actualSize;
+    DescType actualType;
+    OSType eventClass, eventID;
+    
+    if ((err = AEGetAttributePtr(theAE, keyEventClassAttr, typeType, &actualType, &eventClass, sizeof(OSType), &actualSize)) != noErr)
+        return;
+    if (eventClass != kSCMessageClass)
+        return;
+
+    if ((err = AEGetAttributePtr(theAE, keyEventIDAttr, typeType, &actualType, &eventID, sizeof(OSType), &actualSize)) != noErr)
+        return;
+    
+    if (eventID == kSCLoadResult) {
+        OSStatus 
+        (err = AEGetParamPtr(theAE, keyError, typeInteger, &actualType, &error, sizeof(long), &actualSize)) == noErr &&
+        (err = AEGetParamPtr(theAE, keyBundleID, typeText, &actualType, bundleID, sizeof(bundleID), &actualSize)) == noErr)
+        bundleID[actualSize] = 0;
+        printf("patch bundle %s loaded with error status %d\n", bundleID, error);
+    }
+    
+
+}
+
+
+@implementation FSAApp
+
++ (void)initialize;
+{
+    errRec *rec;
+
+    FSA_errors = [[NSMutableDictionary alloc] init];
+    for (rec = &(ERRS[0]) ; rec->err != 0 ; rec++)
+        [FSA_errors setObject: rec->desc forKey: [NSNumber numberWithLong: rec->err]];
+}
+
+- (BOOL)_shouldContinueAfterFrameworkErrorPanelReturnedWithResult:(int)result;
+{
+    switch (result) {
+        case NSAlertOtherReturn:
+            return true;
+        case NSAlertAlternateReturn:
+            [[NSWorkspace sharedWorkspace] openURL: [NSURL URLWithString: FSA_FScriptURL]];
+        case NSAlertDefaultReturn:
+        default:
+            [self terminate: self];
+            return false;
+    }
+}
+
+- (void)finishLaunching
+{
+    patchController = new FSAPatchController(self);
+    patchController->AddPatch((CFStringRef)PatchBundleIdentifier, CFSTR("Contents/Resources/"),
+                              (CFStringRef)PatchBundleName);
+    
+    NSEnumerator *e = [[appList cocoaAppProcessIDs] objectEnumerator];
+    pid_t pid;
+    ProcessSerialNumber psn;
+    OSStatus err;
+    
+    while ( (pid = [[e nextObject] longValue]) != 0) {
+        err = GetProcessForPID(pid, &psn);
+        
+        if (err != noErr) {
+            NSLog(@"Can't get PSN for PID %ld", pid);
+            [appList applicationQuitWithProcessID: pid];
+        } else if (patchController->IsProcessPatched(&psn)) {
+            [appList didPatchProcessID: pid];
+        }
+    }
+
+    // yes, someone could move the framework while the app is running, but they deserve what they get.
+    NSFileManager *fileMgr = [NSFileManager defaultManager];
+    NSArray *libraryDirectories =
+        NSSearchPathForDirectoriesInDomains(NSLibraryDirectory, NSAllDomainsMask, TRUE);
+    NSString *libPath;
+    NSString *frameworkPath;
+    CFBundleRef frameworkBundle = NULL;
+    BOOL isDirectory;
+
+    e = [libraryDirectories objectEnumerator];
+    while ( (libPath = [e nextObject]) != nil) {
+        frameworkPath = [[libPath stringByAppendingPathComponent: @"Frameworks"]
+            stringByAppendingPathComponent: @"FScript.framework"];
+        if ([fileMgr fileExistsAtPath: frameworkPath isDirectory: &isDirectory] && isDirectory) {
+            frameworkBundle = CFBundleCreate(kCFAllocatorDefault, (CFURLRef)[NSURL fileURLWithPath: frameworkPath]);
+            [(id)frameworkBundle autorelease];
+            break;
+        }
+    }
+    FSALog(@"Framework bundle");
+    FSAShow(frameworkBundle);
+    [super finishLaunching];
+    if (frameworkBundle == NULL) {
+        int result = NSRunInformationalAlertPanel(
+            NSLocalizedString(@"F-Script Framework Not Found", "Framework not found alert title"),
+            NSLocalizedString(@"F-Script Anywhere requires the F-Script framework be installed in a Frameworks directory, such as ~/Library/Frameworks or /Library/Frameworks.\n\nTo download F-Script, please visit its Web site\n%@.\n\nIf you believe this message is in error, click '%@'.",
+                              "Framework not found alert message, F-Script Web site URL parameter, 'Continue' button parameter"),
+            NSLocalizedString(@"Quit", "Quit button title"),
+            NSLocalizedString(@"Get F-Script", "'Get F-Script' button title"),
+            NSLocalizedString(@"Continue", "Continue button title"),
+            FSA_FScriptURL, NSLocalizedString(@"Continue", ""));
+        if (![self _shouldContinueAfterFrameworkErrorPanelReturnedWithResult: result]) return;
+    } else {
+        UInt32 version = CFBundleGetVersionNumber(frameworkBundle);
+        FSALog(@"Framework version 0x%x", version);
+        if (version < FSA_FSCRIPT_MIN_VERSION) {
+            NSString *frameworkVersion = (NSString *)CFBundleGetValueForInfoDictionaryKey(frameworkBundle, kCFBundleVersionKey);
+            if (frameworkVersion == nil)
+                frameworkVersion = NSLocalizedString(@"unavailable", "Framework too old 'unavailable' version");
+            int result = NSRunInformationalAlertPanel(
+		NSLocalizedString(@"F-Script Framework Too Old", "Framework too old alert title"),
+		NSLocalizedString(@"F-Script Anywhere %s requires version %@ or later of the F-Script framework be installed in a Frameworks directory, such as ~/Library/Frameworks or /Library/Frameworks. The installed version is %@.\n\nTo upgrade F-Script, please visit its Web site\n%@.\n\nTo use this version of F-Script regardless of the problems you may experience, click '%@'.",
+                                  "Framework too old alert message, FSA version parameter, minimum F-Script version parameter, current F-Script version parameter, F-Script Web site URL parameter, 'Continue' button parameter"),
+		NSLocalizedString(@"Quit", "Quit button title"),
+                NSLocalizedString(@"Get F-Script", "'Get F-Script' button title"),
+                NSLocalizedString(@"Continue", "Continue button title"),
+                FSA_VERSION, FSA_FScriptMinimumVersion, frameworkVersion,
+                FSA_FScriptURL, NSLocalizedString(@"Continue", ""));
+            if (![self _shouldContinueAfterFrameworkErrorPanelReturnedWithResult: result]) return;
+        }
+    }
+
+    NSNotificationCenter *workspaceNotificationCenter = [[NSWorkspace sharedWorkspace] notificationCenter];
+    [workspaceNotificationCenter
+        addObserver: self
+           selector: @selector(applicationDidLaunch:)
+               name: NSWorkspaceWillLaunchApplicationNotification
+             object: nil];
+    [workspaceNotificationCenter
+        addObserver: self
+           selector: @selector(applicationDidTerminate:)
+               name: NSWorkspaceDidTerminateApplicationNotification
+             object: nil];
+    
+    [appListWindow makeKeyAndOrderFront: self];
+}
+
+- (void)installationError:(OSStatus)err inAppWithPID:(pid_t)pid;
+{
+    NSBeginAlertSheet(NSLocalizedString(@"Installation failed", "Unable to install alert title"),
+                      nil, nil, nil, appListWindow, self, nil, nil, nil,
+                      NSLocalizedString(@"F-Script Anywhere was unable to install itself in the selected application (process ID %d), because %@.\n\nThe application may have crashed; restart it if needed.", "Unable to install alert message, PID parameter, 'XXX happened because' explanation parameter"),
+                      pid, FSA_descriptionForOSStatus(err));
+}
+
+- (void)installBundleInAppWithPID:(pid_t)pid;
+{
+    if (pid == -1) return;
+        
+    ProcessSerialNumber psn;
+    OSStatus err = GetProcessForPID(pid, &psn);
+    
+    if (err == noErr)
+        err = patchController->PatchProcess(&psn);
+    
+    if (err != noErr)
+        [self installationError: err inAppWithPID: pid];
+}
+
+- (void)loaderBundleMessage:(NSNotification *)notification;
+{
+    /*
+    if (error) {
+        [self installationError: error inAppWithPID: pid];
+    } else {
+        [appList didPatchProcessID: pid];
+    } */
+}
+
+- (IBAction)installBundleInSelectedApp:(id)sender;
+{
+    [self installBundleInAppWithPID: [appList selectedProcessID]];
+}
+
+// from dock menu only!
+- (IBAction)installBundleInFrontmostApp:(id)sender;
+{
+    NSAssert1([sender tag] > 0, @"Unable to determine frontmost application from %@", sender);
+    [self installBundleInAppWithPID: (pid_t)[sender tag]];
+}
+
+@end
+
+@implementation FSAApp (FSAPatchControllerDelegate)
+
+- (void)controllerIsPatchingApplicationWithProcessID:(pid_t)pid;
+{
+    [appList isPatchingProcessID: pid];
+}
+
+@end
+
+@implementation FSAApp (NSWorkspaceNotifications)
+
+- (void)applicationDidLaunch:(NSNotification *)notification;
+{
+    [appList applicationLaunchedWithProcessID: [[[notification userInfo] objectForKey: @"NSApplicationProcessIdentifier"] intValue]];
+}
+
+- (void)applicationDidTerminate:(NSNotification *)notification;
+{
+    [appList applicationQuitWithProcessID: [[[notification userInfo] objectForKey: @"NSApplicationProcessIdentifier"] intValue]];
+}
+
+@end
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.h	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.h	(revision 153)
@@ -34,4 +34,5 @@
     NSMutableDictionary *appsByPID;
     NSMutableSet *patchedApps;
+    NSMutableSet *patchingApps;    
     IBOutlet NSButton *installButton;
     IBOutlet NSTableView *tableView;
@@ -39,8 +40,10 @@
 
 - (pid_t)selectedProcessID;
+- (void)isPatchingProcessID:(pid_t)pid;
 - (void)didPatchProcessID:(pid_t)pid;
 - (void)applicationLaunchedWithProcessID:(pid_t)pid;
 - (void)applicationQuitWithProcessID:(pid_t)pid;
 - (void)update;
+- (NSArray *)cocoaAppProcessIDs;
 
 @end
